[yesod-static](http://hackage.haskell.org/package/yesod-static) supports generators which run at
compile time which create static resources to embed directly into the executable.  This package
leverages these generators to provide automatic management of [AngularJs](http://angularjs.org/)
code.  During development individual files served and reloaded on every request.  When compiling for
production, the files are minimized, compressed, and then embedded into the executable.

There are several moving parts to integrating AngularJs into Yesod using this module

* yesod-static-angular (this module) - embeds Angular code and directive templates into the static
  subsite
* [karma-ng-hamlet2js-preprocessor](https://npmjs.org/package/karma-ng-hamlet2js-preprocessor) - a
  [karma](http://karma-runner.github.io) plugin to insert Hamlet directive templates into the
  AngularJs template cache.
* [webdriver](https://hackage.haskell.org/package/webdriver) - end to end web testing tool
* [webdriver-angular](https://hackage.haskell.org/package/webdriver-angular) - some Angular specific
  commands for webdriver.  This package contains all the functionality of
  [protractor](https://github.com/angular/protractor) so protractor does not need to be used.
* [hspec-webdriver](https://hackage.haskell.org/package/hspec-webdriver) - some integration code to
  easily write hspec examples which are webdriver tests.

The
[example](https://bitbucket.org/wuzzeb/yesod-static-angular/src/tip/example?at=default)
directory in the source code contains an example application that shows all of the above packages in
action.  Also, I have two blog posts describing the example and its tests.

* [Yesod and AngularJs](http://blog.wuzzeb.org/posts/2013-12-16-yesod-and-angular.html)
* [Testing a Yesod+AngularJs Application](http://blog.wuzzeb.org/posts/2013-12-17-testing-yesod-and-angular.html)
